﻿Public Class frmMain

    '***********************************
    ' 番外編 - 命令語インタプリタ V2.0
    '***********************************

    '名称：変数定義
    '機能：グローバル変数の定義
    Dim Prg(1023) As String '命令語プログラム
    Dim LastPrg As Integer '命令語プログラム最終ポインタ＋１
    Dim RunFlg As Boolean 'スキャン実行許可フラグ
    Dim m(&HFF) As Boolean 'Ｉ／Ｏメモリ
    Dim Reg As Integer '導通状態レジスタ
    Dim Cmd As String 'Ｉ／Ｏメモリの変更指示（文字列）
    Dim FileName As String '命令語プログラムファイル名
    Dim Stk(7) As Integer '導通状態スタック


    Private Sub frmMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '名称：フォームロード処理
        '機能：起動時の初期設定
        Me.Text = "番外編 - 命令語インタプリタ V2.0"
        Timer1.Interval = 100 '１００ｍｓ毎にタイマイベント発生
        Timer1.Enabled = True 'タイマ起動
    End Sub


    Private Sub cmdFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdFile.Click
        '名称：「ファイル読み込み」ボタン処理
        '機能：命令語プログラムを読み込み、配列に格納する
        LastPrg = 0
        FileName = InputBox("命令語ファイル名を入力してください。")
        FileOpen(1, FileName, OpenMode.Input)
        lstPrg.Items.Clear()
        Do While Not EOF(1)
            Prg(LastPrg) = LineInput(1)
            lstPrg.Items.Add(Prg(LastPrg))
            LastPrg = LastPrg + 1
        Loop
        FileClose(1)
    End Sub


    Private Sub cmdScanRun_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdScanRun.Click
        '名称：「スキャン実行」ボタン処理
        '機能：スキャン実行許可フラグをＯＮする（実際のスキャン実行は、タイマ処理でおこなう）
        RunFlg = True 'スキャン実行許可フラグをＯＮ
    End Sub


    Private Sub cmdScanStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdScanStop.Click
        '名称：「スキャン停止」ボタン処理
        '機能：スキャン実行許可フラグをＯＦＦする
        RunFlg = False 'スキャン実行許可フラグをＯＦＦ
    End Sub


    Private Sub cmdDataInput_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdDataInput.Click
        '名称：「データ入力」ボタン処理
        '機能：入力ボックスを開き、Ｉ／Ｏメモリの変更指示（文字列）を受け取る（実際の変更は、タイマ処理でおこなう）
        Cmd = InputBox("「アドレス２桁＋空白１文字＋データ１桁」の形式で、半角４文字で入力してください。（例 2E 1）", "データ入力", "")
    End Sub


    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        '名称：タイマ処理
        '機能：Ｉ／Ｏメモリ変更、命令語プログラムを１スキャン実行、Ｉ／Ｏ表示をおこなう
        Dim i As Integer
        Dim j As Integer
        '指示されたＩ／Ｏメモリを変更する
        If Cmd <> "" Then '変更指示があるとき
            If Cmd.Substring(3, 1) = "1" Then '１のとき
                m(Val("&H" + Cmd.Substring(0, 2))) = True 'ＯＮに変更
            Else '１以外のとき
                m(Val("&H" + Cmd.Substring(0, 2))) = False 'ＯＦＦに変更
            End If
        End If
        Cmd = ""
        If RunFlg = True Then 'スキャン実行許可フラグがＴｒｕｅのとき
            '命令語プログラムを１スキャン実行する
            For i = 0 To LastPrg - 1
                Select Case Prg(i)
                    Case "LD" 'ＬＤ命令のとき
                        i = i + 1
                        Call PushStk(Stk, Reg) '導通状態レジスタをスタックに退避
                        Reg = m(Val("&H" + Prg(i)))
                    Case "LDNOT" 'ＬＤＮＯＴ命令のとき
                        i = i + 1
                        Call PushStk(Stk, Reg) '導通状態レジスタをスタックに退避
                        Reg = Not (m(Val("&H" + Prg(i))))
                    Case "AND" 'ＡＮＤ命令のとき
                        i = i + 1
                        Reg = Reg And m(Val("&H" + Prg(i)))
                    Case "ANDNOT" 'ＡＮＤＮＯＴ命令のとき
                        i = i + 1
                        Reg = Reg And (Not (m(Val("&H" + Prg(i)))))
                    Case "OR" 'ＯＲ命令のとき
                        i = i + 1
                        Reg = Reg Or m(Val("&H" + Prg(i)))
                    Case "ORNOT" 'ＯＲＮＯＴ命令のとき
                        i = i + 1
                        Reg = Reg Or (Not (m(Val("&H" + Prg(i)))))
                    Case "ANDSTACK" 'ＡＮＤＳＴＡＣＫ命令のとき
                        Reg = Reg And PullStk(Stk)
                    Case "ORSTACK" 'ＯＲＳＴＡＣＫ命令のとき
                        Reg = Reg Or PullStk(Stk)
                    Case "OUT" 'ＯＵＴ命令のとき
                        i = i + 1
                        m(Val("&H" + Prg(i))) = Reg
                    Case "END" 'ＥＮＤ命令のとき
                        Exit For
                    Case Else '上記以外のとき
                        If Prg(i).Substring(0, 2) <> "/*" Then End 'コメント以外のとき、終了
                End Select
            Next
        End If
        'Ｉ／Ｏメモリを画面に表示する
        lstMon.Items.Clear()
        For i = 0 To &HF0 Step 16
            lstMon.Items.Add(OnOff(m(i + 0)) & OnOff(m(i + 1)) & OnOff(m(i + 2)) & OnOff(m(i + 3)) & " " _
                & OnOff(m(i + 4)) & OnOff(m(i + 5)) & OnOff(m(i + 6)) & OnOff(m(i + 7)) & " " _
                & OnOff(m(i + 8)) & OnOff(m(i + 9)) & OnOff(m(i + 10)) & OnOff(m(i + 11)) & " " _
                & OnOff(m(i + 12)) & OnOff(m(i + 13)) & OnOff(m(i + 14)) & OnOff(m(i + 15)) _
                & " : " & Hex(i) & "-" & Hex(i + &HF))
        Next
    End Sub


    Private Function OnOff(ByVal x As Boolean) As String
        '名称：ｂｏｏｌｅａｎ－文字列変換
        '機能：ｂｏｏｌｅａｎを０または１の文字列に変換する
        If x = True Then 'Ｔｒｕｅのとき
            OnOff = "1" '１を返す
        Else 'Ｆａｌｓｅのとき
            OnOff = "0" '０を返す
        End If
    End Function


    Private Sub PushStk(ByVal x() As Integer, ByVal y As Integer)
        '名称：ＰＵＳＨ動作
        '機能：スタック（配列）にデータをＰＵＳＨ（シフト）する
        x(7) = x(6)
        x(6) = x(5)
        x(5) = x(4)
        x(4) = x(3)
        x(3) = x(2)
        x(2) = x(1)
        x(1) = x(0)
        x(0) = y
    End Sub


    Private Function PullStk(ByVal x() As Integer) As Integer
        '名称：ＰＵＬＬ動作
        '機能：スタック（配列）からデータをＰＵＬＬ（シフト）する
        PullStk = x(0)
        x(0) = x(1)
        x(1) = x(2)
        x(2) = x(3)
        x(3) = x(4)
        x(4) = x(5)
        x(5) = x(6)
        x(6) = x(7)
        x(7) = 0
    End Function


End Class